org.apache.ignite.internal.managers.deployment

## Interface GridDeploymentStore

All Known Implementing Classes:
  GridDeploymentPerLoaderStore, GridDeploymentPerVersionStore

    public interface GridDeploymentStore

Interface for all deployment stores.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addParticipants(Map<UUID,IgniteUuid> allParticipants, Map<UUID,IgniteUuid> addedParticipants)` Adds participants to all deployments.
`GridDeployment` `explicitDeploy(Class<?> cls, ClassLoader clsLdr)` Explicitly deploys class.
`void` `explicitUndeploy(@Nullable UUID nodeId, String rsrcName)`
`@Nullable GridDeployment` `getDeployment(GridDeploymentMetadata meta)`
`@Nullable GridDeployment` `getDeployment(IgniteUuid ldrId)` Gets class loader based on ID.
`Collection<GridDeployment>` `getDeployments()`
`void` `onKernalStart()` Kernal started callback.
`void` `onKernalStop()` Kernel stopping callback.
`@Nullable GridDeployment` `searchDeploymentCache(GridDeploymentMetadata meta)`
`void` `start()` Starts store.
`void` `stop()` Stops store.

### Method Detail

#### start

    void start()
        throws IgniteCheckedException

Starts store.

Throws:
  `IgniteCheckedException` - If start failed.

#### stop

    void stop()

Stops store.

#### onKernalStart

    void onKernalStart()
                throws IgniteCheckedException

Kernal started callback.

Throws:
  `IgniteCheckedException` - If callback execution failed.

#### onKernalStop

    void onKernalStop()

Kernel stopping callback.

#### getDeployment

    @Nullable
    @Nullable GridDeployment getDeployment(GridDeploymentMetadata meta)

Parameters:
  `meta` - Deployment metadata.
Returns:
  Deployment.

#### searchDeploymentCache

    @Nullable
    @Nullable GridDeployment searchDeploymentCache(GridDeploymentMetadata meta)

Parameters:
  `meta` - Deployment meatdata.
Returns:
  Grid deployment instance if it was finded in cache, `null` otherwise.

#### getDeployment

    @Nullable
    @Nullable GridDeployment getDeployment(IgniteUuid ldrId)

Gets class loader based on ID.

Parameters:
  `ldrId` - Class loader ID.
Returns:
  Class loader of `null` if not found.

#### getDeployments

    Collection<GridDeployment> getDeployments()

Returns:
  All current deployments.

#### explicitDeploy

    GridDeployment explicitDeploy(Class<?> cls,
                                  ClassLoader clsLdr)
                           throws IgniteCheckedException

Explicitly deploys class.

Parameters:
  `cls` - Class to explicitly deploy.
  `clsLdr` - Class loader.
Returns:
  Grid deployment.
Throws:
  `IgniteCheckedException` - Id deployment failed.

#### explicitUndeploy

    void explicitUndeploy(@Nullable
                          @Nullable UUID nodeId,
                          String rsrcName)

Parameters:
  `nodeId` - Optional ID of node that initiated request.
  `rsrcName` - Undeploys all deployments that have given

#### addParticipants

    void addParticipants(Map<UUID,IgniteUuid> allParticipants,
                         Map<UUID,IgniteUuid> addedParticipants)

Adds participants to all deployments.

Parameters:
  `allParticipants` - All participants to determine which deployments to add to.
  `addedParticipants` - Participants to add.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.9.0
Release Date | : October 15 2020